<?php
/*
Plugin Name: Post notifier
Plugin URI: http://www.x2b4.com/2009/11/03/get-notifications-from-edited-articles-in-wordpress/
Description: Sends an email to the post author when a post is modified.
Author: x2b4
Version: 1.0
Author URI: http://www.x2b4.com/
*/

//based on http://www.dagondesign.com/articles/draft-notification-plugin-for-wordpress/

function notification_process($id) {

	global $wpdb;
	
	$tp = $wpdb->prefix;

	$result = $wpdb->get_row("
		SELECT post_status, post_title, user_login, user_nicename, display_name, {$tp}users.ID
		FROM {$tp}posts, {$tp}users 
		WHERE {$tp}posts.post_author = {$tp}users.ID 
		AND {$tp}posts.ID = '$id'
	");

	$user_info = get_userdata($result->ID);
	$recipient = $user_info->user_email; 
 	
	global $current_user;
	get_currentuserinfo();
	
	if (($result->ID != $current_user->ID))
	{
		$message = "";
		$message .= "A post has been edited on '" . get_bloginfo('name') . "'\n\n";
		$message .= "Title: " . $result->post_title . "\n\n";
		$message .= "Original author: " . $result->display_name . "\n\n";
		$message .= "Editor: " . $current_user->display_name . "\n\n";
		$message .= "Link: " . get_permalink($id) . "\n\n";
		
		$result2 = $wpdb->get_row("SELECT {$tp}posts.ID FROM {$tp}posts WHERE `post_type` = 'revision' AND `post_parent` ='".$id."' ORDER BY `ID` DESC");
		$message .= "Diff: ".get_bloginfo("wpurl")."/wp-admin/revision.php?action=diff&right=".$id."&left=".$result2->ID;
		
		$subject = "Post '" . $result->post_title . "' updated on '" . get_bloginfo('name') . "' by " . $current_user->display_name;
		
		$user_info = get_userdata($result->ID);
		$recipient = $user_info->user_email; 
		$headers = 'From: Wordpress<wordpress@x2b4.com>' . "\r\n";
		mail($recipient, $subject, $message, $headers);
	}

}

add_action('publish_post', 'notification_process');

?>